<template>
    <div class="app-rawitem-carousel">       
        <el-carousel class="carsouel-container" 
            height="150px" 
            indicator-position="outside" 
            :autoplay="false"
            :interval="swipeConfig.interval"
            >
            <el-carousel-item v-for="item in swipeData" :key="item.key">
                <div class="carousel-img-item">
                    <img class="app-carouse-img" v-if="item.type === 'img'" :src="item.imgPath" @error="imgError" />
                    <i v-else-if="item.type === 'icon'" :class="item.iconClass" ></i>
                </div>
            </el-carousel-item>
        </el-carousel>
    </div>
</template>
<script lang='ts'>
import { Component, Vue, Prop, Watch } from 'vue-property-decorator';
@Component({})
export default class AppCarousel extends Vue {
    /**
     * 父项所有数据
     *
     * @type {*}
     * @memberof AppPresetCarousel
     */
    @Prop() public data?: any;

    /**
     * @description 轮播图数据
     * @param {*}
     * @memberof AppCarousel
     */
    @Prop() public value?: any;

    /**
     * @description 轮播图样式
     * @param {*}
     * @memberof AppCarousel
     */
    @Prop() public cssStyle?: any;

    /**
 * @description 样式表
 * @param {*}
 * @memberof AppCarousel
 */
    @Prop() public cssClass?: any;

    /**
     * 名称
     *
     * @type {string}
     * @memberof AppCarousel
     */
    @Prop() public name!: string;

    /**
     * 类型
     *
     * @type {string}
     * @memberof AppCarousel
     */
    @Prop() public type?: string;

    /**
     * @description 轮播图图片所有项数据
     * @memberof AppCarousel
     */

    public swipeData: any[] = [];

    /**
     * @description 轮播图配置
     * @memberof AppCarousel
     */
    public swipeConfig: any = {};

    /**
     * data值变化
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof AppCarousel
     */
    @Watch('value', { immediate: true, deep: true })
    public onDataChange(newVal: any, oldVal: any) {
        if (newVal) {
            // this.handleSwipData(newVal);
        }
    }

    /**
     * @description 构建之前
     * @memberof AppCarousel
     */
    created() {
        //处理轮播图-动态数据
        if (this.type === "FIELD_CAROUSEL") {
            if (this.value && typeof this.value === 'string') {
                const swipeData = JSON.parse(this.value);
                this.handleSwipData(swipeData);
            }
        } else if (this.type === "STATIC_CAROUSEL") {
            //处理轮播图-静态数据
            this.handleSwipData(this.value);
        }
    }

    /**
    * @description 处理轮播图数据
    * @memberof AppCarousel
    */
    private handleSwipData(data: any) {
        if (data && data.length > 0) {
            const configItem = data.findIndex((item: any) =>
                Object.is(item.key, "autoplay")
            );
            if (configItem > -1) {
                // 有配置参数就截掉配置参数
                this.swipeData = data.slice(0, -2);
                this.swipeConfig = this.setSwipeConfig(data.slice(-2));
            } else {
                this.swipeData = data;
                this.swipeConfig = this.setSwipeConfig(data);
            }
        }
    }

    /**
     * @description 设置轮播图配置
     * @param {*}
     * @memberof AppRawItem
     */
    private setSwipeConfig(data: any) {
        const autoPlay: any =
            data.find((item: any) => Object.is(item.key, "autoplay")) || {};
        const timeSpan: any =
            data.find((item: any) => Object.is(item.key, "timespan")) || {};
        let isauto = false;
        let timespan = 0;
        if (autoPlay.value && Object.is(autoPlay.value, "1")) {
            isauto = true;
        }
        if (timeSpan.value) {
            timespan = Number(timeSpan.value);
        }
        return {
            isAuto: isauto,
            timeSpan: timespan,
        };
    }

    /**
     * img src错误
     *
     * @param {*} $event
     * @memberof AppCarousel
     */
    imgError($event: any) {
        let img = $event.srcElement;
        if (img && !img.imgSign) {
            if (img && !img.imgSign) {
                img.src = 'assets/img/404.png';
                img.imgSign = true;
                img.imgSign = true;
            }
            img.onerror = null;
        }
    }
}
</script>

<style lang='less'>
@import './app-rawitem-carousel.less';
</style>